/****************************************************************************/
/*																			*/
/*		VisualMonitor_E[hTvvOiREALiŁj				*/
/*																			*/
/*			X^[gAbv												*/
/*																			*/
/*			Copyright	:: ijAt@vWFNg						*/
/*			Cpu			:: SH7032(SH1)										*/
/*			Language	:: GCC												*/
/*			File Name	:: boot.c											*/
/*																			*/
/****************************************************************************/
#include	"sh_7032.h"
#include	"gmachine.h"
#include	"userlog.h"
#include	"c:\reali\include\reali.h"	/*REALi CXg[ꂽɂ
                                          pXwύXĉ*/

#define		UserLogAdd	0x0A03F000		/* ޯpRAM̈̐擪w 	*/

/********************************/
/*	vg^Cv錾			*/
/********************************/
void	boot(void);
void	ap_main(void);
void	port_init(void),int_init(void);
void	ITU_timer_init(void);
void	task1(void),task2(void),task3(void);
void	TLogPut(char *);
void	itu0_1ms(void);

extern void	itim_hdr(void);

/********************************/
/*	O[oϐ錾			*/
/********************************/
long	count;

void boot(void)
{
	ap_main();
}

/**/
INT reali_stk[0x2000];
T_SYS const t_mysys = {
		reali_stk,						/* ̈̐擪Ԓn				*/
		sizeof(reali_stk),				/* ̈̃TCY				*/
		3,								/* őDx						*/
		3,								/* ő^XN						*/
		0,								/* CxgtO					*/
		1,								/* Z}tH						*/
		0,								/* C{bNX					*/
		0,								/* v[					*/
		0,								/* Nnh				*/
		0,								/* A[nh				*/
		SR_IMS07,						/* 荞݃}XN					*/
		1								/* ZJEg					*/
};
/**/
/************************************************************/
/*	C												*/
/************************************************************/
void ap_main(void)
{
	ER er;

	/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
	/* ́A[U[vOdlɉăR[fBOĉB	*/
	/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
	/*++++++++++++++++++++++++++*/
	/* ȉ͎QlvOł */
	/*++++++++++++++++++++++++++*/

	chg_ims(SR_IMS14);
	port_init();						/* I/O|[gݒ				*/
	int_init();							/* 荞݃Rg[ݒ		*/
	UserLogInit(UserLogAdd);			/* [U[OAhXZbg		*/

	ini_sys((T_SYS *)(&t_mysys));		/* VXȅ					*/

	UserLogPut("*-------------------------------------------*");
	UserLogPut("*       <<< REALi Sample Program >>>        *");
	UserLogPut("*-------------------------------------------*");

	UserLogPut("create task1 [priority=2]");
	er=	cre_tsk(1,task1,2,0x400);		/* ^XN1 ̐					*/
	if( er != E_OK ){
		UserLogPut("cre_tsk1 error");
	}

	UserLogPut("create task2 [priority=2]");
	er = cre_tsk(2,task2,2,0x400);		/* ^XN2 ̐					*/
	if( er != E_OK ){
		UserLogPut("cre_tsk2 error");
	}

	/* AChO^XNƂĎgp */
	UserLogPut("create task3 [priority=1]");
	er = cre_tsk(3,task3,1,0x400);		/* ^XN3 ̐					*/
	if( er != E_OK ){
		UserLogPut("cre_tsk3 error");
	}

	sta_sys(3);							/* }`^XN̊Jn				*/
										/* ^XN3 N					*/
	for(;;);
}

/************************************************************/
/*	I/O|[gݒ										*/
/************************************************************/
void port_init(void)
{
	PFC.PAIOR.BIT.B15 = 1;				/* PA15 = output					*/
	PFC.PAIOR.BIT.B14 = 1;				/* PA14 = output					*/
	PFC.PACR1.BIT.MD15 = 0;				/* PA15 = I/O						*/
	PFC.PACR1.BIT.MD14 = 0;				/* PA14 = I/O						*/
}

/************************************************************/
/*	CMT0^C}ݒ										*/
/************************************************************/
void ITU_timer_init(void)
{
	def_int_hdr( 80, (void*)itim_hdr );		/* 荞݃nh̐ݒ			*/
	ITU0.TCR.BYTE = 0x23;				/* Ϻ۰ڼ޽					*/
										/* Ӂ^W							*/
	ITU0.TSR.BYTE = 0x00;				/* Ͻðڼ޽					*/
	ITU0.GRA = 0x09c4;					/* ުڼ޽A						*/
										/* 1ms								*/
	ITU0.TIER.BYTE = 0x79;				/* ϲĲȰڼ޽			*/
										/* IMFAޯĂɂ銄荞݂		*/
	ITU.TSTR.BYTE = 0x61;				/* Ͻڼ޽						*/
										/* TCNT0 Ľ					*/
}

/************************************************************/
/*	荞݃Rg[ݒ							*/
/************************************************************/
void int_init(void)
{
										/* D惌xݒ 15 <- 0  0=MASK	*/
	INTC.IPRC.WORD = 0x0070;			/* hstOD惌xV			*/
}

/************************************************************/
/*	TASK1													*/
/************************************************************/
void task1(void)
{
	static char	flag;

	TLogPut("***** TASK1 START !! *****");
	count = 0;
	while(1){
		++count;
		if( count >= 1000 ) {
			count = 0;
			if( flag == 0 ) {
				flag = 1;
				PA.DR.BIT.B14 = 1;		/* PA14 ON							*/
			} else {
				flag = 0;
				PA.DR.BIT.B14 = 0;		/* PA14 OFF							*/
			}
		}
	}
}

/************************************************************/
/*	TASK2													*/
/************************************************************/
void task2(void)
{
	static char	flag;

	TLogPut("***** TASK2 START !! *****");
	while(1){
		wai_tsk(3000);					/* 3bҋ@							*/
		if( flag == 0 ) {
			flag = 1;
			PA.DR.BIT.B15 = 1;			/* PA15 ON							*/
		} else {
			flag = 0;
			PA.DR.BIT.B15 = 0;			/* PA15 OFF							*/
		}
	}
}

/************************************************************/
/*	TASK3 iAChO^XNj							*/
/************************************************************/
void task3(void)
{
	ITU_timer_init();					/* CMT^C}ݒ				*/
	sta_tsk(1);							/* ^XN1 N					*/
	sta_tsk(2);							/* ^XN2 N					*/
	TLogPut("***** TASK3 START !! *****");
	TLogPut("  TASK3 change pri 1 -> 3");
	chg_pri(TSK_SELF,3);				/* Dx 1 -> 3 ɕύX			*/

	for(;;);
}

/************************************************************/
/*	^XÑ[U[O								*/
/************************************************************/
void TLogPut(char *s)
{
	wai_sem(1);							/* Z}tH҂					*/
	UserLogPut( s );
	sig_sem(1);							/* Z}tHM					*/
}

/************************************************************/
/*	CMT0^C}荞݁i1msj								*/
/************************************************************/
void itu0_1ms(void)
{
	ITU0.TSR.BYTE &= (~0x01);			/* ^C}Xe[^XNA			*/

	irot_rdq(2);						/* ^XNfBL[]			*/
	sys_clk();
	sys_tim();
	ret_int();
}

