#include	"sh7040.h"
#include	"gmachine.h"
#include	"userlog.h"
#define		UserLogAdd	0x004FF000	/* ޯpRAM̈̐擪w肷	*/

void	boot(void);
void	__main(void);
int		main(void);

void	sectionInit(void);
void	cmt0_init(void);
void	int_cmi0(void);
void	mtu0_init(void);
void	int_mtu0(void);

long	UserLogTimer = 0;

/************************************/
/*	__main(_~[)					*/
/************************************/
void __main(void)
{
}

/************************************/
/*	CPU						*/
/************************************/
void boot(void)
{
	/* oXݒ */
	BSC.BCR1.WORD = 0x200f;				/*lst䋖					*/
										/*CS0oXTCYPUrbg			*/
										/*CS1oXTCYPUrbg			*/
										/*CS2oXTCYPUrbg			*/
										/*CS3oXTCY  Wrbg			*/
	BSC.BCR2.WORD = 0x55f0;				/*CS3TCNԃACh	PACh	*/
										/*CS2TCNԃACh	PACh	*/
										/*CS1TCNԃACh	PACh	*/
										/*CS0TCNԃACh	PACh	*/
										/*AANZXAChL(CS0123)	*/
										/*AANZXACh(--)		*/
										/*brAT[ggL(--)			*/
										/*brAT[gg(0~3)			*/
	BSC.WCR1.WORD = 0x2222;				/*CS3ԊOEFCg	QEFCg	*/
										/*CS2ԊOEFCg	QEFCg	*/
										/*CS1ԊOEFCg	QEFCg	*/
										/*CS0ԊOEFCg	QEFCg	*/
	BSC.WCR2.WORD = 0x000f;				/*cl`ݸٱڽӰޱ		*/
										/*cq`lԃEFCgw	O	*/
										/*brԃEFCgw	PT	*/
	BSC.DCR.WORD = 0x0000;				/*DRAMGARg[			*/
										/*RASv`[WTCN		1.5	*/
										/*RAS-CASxTCN			1	*/
										/*RASAT[gTCN			2.5	*/
										/*DARMCgTCNEFCg	2s0w*/
										/*DARM[hTCNEFCg	2s0w*/
										/*DRAMAChTCN			Ȃ*/
										/*o[XgCl[u			֎~*/
										/*RAS_E[h		Abv[h*/
										/*DRAMoX					8bit*/
										/*DRAMAhX}`vNX	9bit*/

	/* hn|[gݒ */
	PFC.PACRH.WORD = 0x0000;			/*PA23~16							*/
	PFC.PACRL1.WORD = 0x0050;			/*PA11,10 -> CS1,0 OUT				*/
										/*PA15~12,9,8						*/
	PFC.PACRL2.WORD = 0x0005;			/*PA1 -> TXD0						*/
										/*PA0 -> RXD0						*/
										/*PA7~2								*/
	PFC.PBCR1.WORD = 0x000a;			/*PB9,8	-> A21,20					*/
	PFC.PBCR2.WORD = 0xa005;			/*PB7,6,1,0 -> A19~16				*/
										/*PB5~2								*/
	PFC.PCCR.WORD = 0xffff;				/*PC15~0 -> A15~0					*/
	PFC.PDCRH1.WORD = 0x0000;			/*PD31~24 OUT						*/
	PFC.PDCRH2.WORD = 0x0000;			/*PD23~16 OUT						*/
	PFC.PDCRL.WORD = 0xffff;			/*PD15~0 -> D15~0					*/
	PFC.PECR1.WORD = 0x0000;			/*PE15~8							*/
	PFC.PECR2.WORD = 0x0000;			/*PE7~0								*/
	PFC.IFCR.WORD = 0x0000;

	PFC.PAIORH.WORD = 0x0000;			/*[OUT]-- [IN]PA23~16				*/
	PFC.PAIORL.WORD = 0x0000;			/*[OUT]-- [IN]PA15~0				*/
	PFC.PBIOR.WORD = 0x003c;			/*[OUT]PB5~2 [IN]--					*/
	PFC.PCIOR.WORD = 0x0000;			/*[OUT]-- [IN]--					*/
	PFC.PDIORH.WORD = 0xffff;			/*[OUT]PD30~16 [IN]--				*/
	PFC.PDIORL.WORD = 0x0000;			/*[OUT]-- [IN]--					*/
	PFC.PEIOR.WORD = 0xffff;			/*[OUT]PE15~0 [IN]--				*/

	sectionInit();						/*					*/

	main();
}

/************************************/
/*	MAIN֐						*/
/************************************/
int
main()
{
	char	buf[10] = "Count =  ";
	short	UserLogCount = 0;

	cmt0_init();						/*	CMT0					*/
	mtu0_init();						/*	MTU0					*/

	UserLogInit(UserLogAdd);			/* հް۸޸ڽݒ			*/

	set_imask(0);						/*	荞݃}XN			*/

	for(;;) {
		if ( 100 <= UserLogTimer ) {
			UserLogTimer = 0;
			buf[8] = UserLogCount | 0x30;
			UserLogPut(&buf[0]);		/* հް۸ޕ\			*/
			UserLogCount++;
			if (UserLogCount >= 10 ){
				UserLogCount = 0;
			}
		}
	}
	return 0;
}

/************************************/
/*	ZNV				*/
/************************************/
extern char etext, sdata, edata, bss_start, end;
void
sectionInit()
{
	char	*src;
	char	*dst;

	/*	f[^̈	*/
	src	= &etext;
	dst	= &sdata;
	while (dst < &edata) {
		*dst++	= *src++;
	}
	/*	f[^̈	*/
	for ( dst = &bss_start; dst < &end; dst++ ) {
		*dst = 0;
	}
}
/************************************/
/*	CMT0						*/
/************************************/
void cmt0_init(void)
{
	def_int_hdr(144,(void*)int_cmi0);	/*荞݃nh̐ݒ			*/
	INTC.IPRG.WORD		|= 0x0070;		/*	CMT0 InterruptLevel = 7			*/

	CMT.CMSTR.WORD		&= ~0x0001;		/*	CMCNTJEg~				*/
	CMT0.CMCSR.WORD		= 0x0040;		/*	NbNӁ^W, ݋		*/
	CMT0.CMCOR			= 0x7800-1;		/*	(24.576MHz/8)/30720 = 10msec	*/
	CMT.CMSTR.WORD		|= 0x0001;		/*	CMCNTJEgJn				*/
}

/************************************/
/*	CMT0荞					*/
/************************************/
#pragma interrupt
void int_cmi0(void)
{
	static char		flag;

	CMT0.CMCSR.WORD &= ~0x0080;			/*bleNA				*/
	/*	|[gON/OFF	*/
	if( 0 != flag ) {
		PE.DR.WORD = 0xffff;
		flag = 0;
	} else {
		PE.DR.WORD = 0x0000;
		flag = 1;
	}
	UserLogTimer++;
}

/************************************/
/*	MTU0						*/
/************************************/
void mtu0_init(void)
{
	def_int_hdr( 88,(void*)int_mtu0);		/* 荞݃nh̐ݒ		*/
	INTC.IPRD.WORD |= 0x7000;				/*lstOD惌x				*/

	MTU0.TCR.BYTE = 0x23;					/* sfq`̃RyA}b`		*/
											/* オGbWŃJEg	*/
											/* Ӂ^USŃJEg			*/
	MTU0.TIOR.BYTE.H = 0x00;				/* TGR0B,TGR0A					*/
	MTU0.TIOR.BYTE.L = 0x00;				/* TGR0D,TGR0C					*/
	MTU0.TIER.BYTE = 0x41;					/* sfe`荞ݗv	*/
	MTU0.TGRA = 0x0780-1;					/* POJE^				*/
	MTU0.TCNT = 0x0000;						/* JE^NA				*/
	MTU0.TSR.BYTE = 0x00;					/* Xe[^XNA				*/

	PWM.TOER.BYTE = 0xc0;					/* lsto͋֎~				*/
	MTU.TSTR.BYTE = 0x01;					/* X^[gWX^				*/
}

/************************************/
/*	MTU0荞					*/
/************************************/
#pragma interrupt
void int_mtu0(void)
{
	static char		flag;
	unsigned char	wk;

	wk = MTU0.TSR.BYTE;
	MTU0.TSR.BYTE = 0xc0;

	/*	|[gON/OFF	*/
	if( flag == 0 ) {
		PD.DR.WORD.H |= 0xffff;				/* oc@nm				*/
		flag = 1;
	} else {
		PD.DR.WORD.H &= ~0xffff;				/* oc@nee				*/
		flag = 0;
	}
}
