OUTPUT_FORMAT("coff-sh")
OUTPUT_ARCH(sh)
MEMORY
{
  rom    : o = 0x0a000400, l = 0x0001fc00
  ram    : o = 0x0a020000, l = 0x0001f000
  stack  : o = 0x0a03eff0, l = 0x00000010
}
SECTIONS
{
  .text :
  {
     _stext = . ; 
    *(.vector)                     
    *(.text)
    *(.strings)
     _etext = . ; 
  }  > rom
  .data : AT ( ADDR (.text) + SIZEOF (.text) )
  {
     _sdata = . ; 
    *(.data)
     _edata = . ; 
  }  > ram
  .bss :
  {
     _bss_start = . ; 
    *(.bss)
    *(COMMON)
     _end = . ;  
  }  > ram
  .stack :
  {
     _stack_top = . ; 
    *(.stack)
  } > stack
}
