/****************************************************************************/
/*																			*/
/*		SH3 MPUˑAVisuaMonitrp荞݃nh̐ݒ֐				*/
/*																			*/
/*			Copyright   :: At@vWFNg							*/
/*			Cpu         :: SH3												*/
/*			Language    :: GCC												*/
/*			File Name   :: gmachine.c										*/
/*																			*/
/****************************************************************************/

/*	荞݃e[u̍\̐錾	*/
struct _int_table
{
	void (* vect_table[0x00000080])(void);
	unsigned long int_pri[0x00000080];
	void (* trap_table[0x00000100])(void);
};

/*	荞݃e[u̐錾	*/
struct _int_table * IntTable;

/*----------------------------------------------------------------------------
@\  荞݃}XN̐ݒB
  unsigned short mask : 荞݃}XN 0 - 15
ߒl  void
----------------------------------------------------------------------------*/
void set_imask( unsigned short mask )
{
	unsigned long uh;

	mask <<= 4;
	mask &= 0x00f0;
	asm("	stc	sr,%0	":"=r"(uh):);
	uh &= 0xffffff0f;
	uh = uh | mask;
	asm("	ldc	%0,sr "::"r"(uh));
}

/*----------------------------------------------------------------------------
@\  荞݃}XN擾
  void
ߒl  unsigned shor : 荞݃}XN̒l  0 - 15
----------------------------------------------------------------------------*/
unsigned short get_imask( void )
{
	unsigned long uh;

	asm("	stc	sr,%0	":"=r"(uh):);
	uh &= 0x00f0;
	uh >>= 4;
	return ( unsigned short )uh;
}

/*----------------------------------------------------------------------------
@\  CR WX^ɒlݒ肷
  unsigned long cr : ݒ肷l
ߒl  void
----------------------------------------------------------------------------*/
void set_cr( unsigned long cr )
{
	asm("	mov		%0,r0 "::"r"(cr) );
	asm("	ldc		r0,sr ");
}

/*----------------------------------------------------------------------------
@\  CR WX^̒l擾
  void
ߒl  unsigned long : CRWX^̒l
----------------------------------------------------------------------------*/
unsigned long get_cr( void )
{
	unsigned long cr;

	asm("	stc	sr,%0	":"=r"(cr):);
	return cr;
}

/*----------------------------------------------------------------------------
@\  VBR(xN^[x[XWX^)̐ݒςB
  void base : OxN^[̐擪AhX
ߒl  void
----------------------------------------------------------------------------*/
void set_vbr( void *base)
{
	asm("	ldc		%0,vbr "::"r"(base));
}

/*----------------------------------------------------------------------------
@\  VBR(xN^[x[XWX^)擾B
  void
ߒl  void * : OxN^[̐擪AhX
----------------------------------------------------------------------------*/
void *get_vbr( void )
{
	unsigned long *vbr;

	asm("	stc vbr,%0 ":"=r"(vbr):);
	return (void *)vbr;
}

/*----------------------------------------------------------------------------
@\  荞݃e[ũAhXݒB
  unsigned long addr     : 荞݃e[u̐擪AhX
ߒl  void
----------------------------------------------------------------------------*/
void vect_table_address(unsigned long addr)
{
	IntTable = (struct _int_table *)addr;
}

/*----------------------------------------------------------------------------
@\  荞݃nh̐ݒB
  unsigned short  intno  : 荞݃xN^ԍ 0 - 128
  void *inthdr(void)     : 荞݃[`̃AhX
  unsigned long level    : 荞݃x 0 - 16
ߒl  void
----------------------------------------------------------------------------*/
void def_int_hdr(unsigned short  intno,void (*inthdr)(void),unsigned long level)
{
	IntTable->vect_table[intno] = inthdr;
	IntTable->int_pri[intno] = level;
}

/*----------------------------------------------------------------------------
@\  gbv荞݃nh̐ݒB
  unsigned short  intno  : 荞݃xN^ԍ 0 - 255
  void *hdr(void)        : gbv[`̃AhX
ߒl  void
----------------------------------------------------------------------------*/
void def_trap_hdr(unsigned short  intno,void (*hdr)(void))
{
	IntTable->trap_table[intno] = hdr;
}

/*----------------------------------------------------------------------------
@\  X[vԂɈڍs
  void
ߒl  void
----------------------------------------------------------------------------*/
void sleep( void )
{
	asm(" sleep ");
}
