#include	"sh7032.h"
#include	"gmachine.h"
#include	"userlog.h"
#define		UserLogAdd	0x0A03F000	/* ޯpRAM̈̐擪w肷	*/

void	boot(void);
void	__main(void);
int		main(void);

void	sectionInit(void);
void	itu0_init(void);
void	int_itu0(void);

long	UserLogTimer = 0;

/************************************/
/*	__main(_~[)					*/
/************************************/
void __main(void)
{
}

/************************************/
/*	CPU						*/
/************************************/
void boot(void)
{
	/* oXݒ */
	BSC.BCR.WORD = 0x0000;					/*	Area1	O		*/
											/*	Area6	O		*/
											/*	m[}[h				*/
											/*	RDf[eB50%				*/
											/*	~WRH,~WRL,~A0L			*/
	BSC.WCR1.WORD = 0xffff;					/*	Area0`7	WAITL		*/
	BSC.WCR3.WORD = 0x9800;					/*	Area0,2	PXe[g			*/
											/*	Area6	SXe[g			*/

	/* hn|[gݒ */
	PFC.PBCR1.WORD = 0x00a0;				/*	PB15~12,9~8		ėpo	*/
	PFC.PBCR2.WORD = 0x0000;				/*	PB7~0			ėpo	*/
	PFC.PBIOR.WORD = 0xffff;				/*	[OUT]PB15~PB0				*/

	sectionInit();							/*					*/

	main();
}

/************************************/
/*	MAIN֐						*/
/************************************/
int
main()
{
	char	buf[10] = "Count =  ";
	short	UserLogCount = 0;

	itu0_init();

	UserLogInit(UserLogAdd);			/* հް۸޸ڽݒ			*/

	set_imask(0);						/*	荞݃}XN			*/

	for(;;) {
		if ( 100 <= UserLogTimer ) {
			UserLogTimer = 0;
			buf[8] = UserLogCount | 0x30;
			UserLogPut(&buf[0]);		/* հް۸ޕ\			*/
			UserLogCount++;
			if (UserLogCount >= 10 ){
				UserLogCount = 0;
			}
		}
	}
	return 0;
}

/************************************/
/*	ZNV				*/
/************************************/
extern char etext, sdata, edata, bss_start, end;
void
sectionInit()
{
	char	*src;
	char	*dst;

	/*	f[^̈	*/
	src	= &etext;
	dst	= &sdata;
	while (dst < &edata) {
		*dst++	= *src++;
	}
	/*	f[^̈	*/
	for ( dst = &bss_start; dst < &end; dst++ ) {
		*dst = 0;
	}
}

/************************************/
/*	ITU0						*/
/************************************/
void itu0_init(void)
{
	def_int_hdr( 80, (void*)int_itu0 );			/* 荞݃nh̐ݒ		*/
	INTC.IPRC.WORD = 0x0070;			/*	ITU0 InterruptLevel = 7			*/


	ITU0.TCR.BYTE = 0x23;					/* Ϻ۰ڼ޽				*/
											/* Ӂ^W						*/

	ITU0.TSR.BYTE = 0x00;					/* Ͻðڼ޽				*/

	ITU0.GRA = 0x61a8 - 1;					/* ުڼ޽A					*/
											/* 1/(20MHz/8/25000)=10ms		*/

	ITU0.TIER.BYTE = 0x79;					/* ϲĲȰڼ޽		*/
											/* IMFAޯĂɂ銄荞݂	*/

	ITU.TSTR.BYTE = 0x61;					/* Ͻڼ޽					*/
											/* TCNT0 Ľ				*/
}

/************************************/
/*	ITU0荞					*/
/************************************/
#pragma interrupt
void int_itu0(void)
{
	static char		flag;
	unsigned char	wk;

	wk = ITU0.TSR.BYTE;
	ITU0.TSR.BYTE = wk & ~0x01;				/*	IMFANA					*/

	/*	|[gON/OFF	*/
	if( flag == 0 ) {
		PB.DR.WORD |= 0xf3ff;				/*	PB ON		*/
		flag = 1;
	} else {
		PB.DR.WORD &= ~0xf3ff;				/*	PB OFF		*/
		flag = 0;
	}
	UserLogTimer++;
}
